"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/delete-old.lambda.ts
var delete_old_lambda_exports = {};
__export(delete_old_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(delete_old_lambda_exports);
var import_client_rds = require("@aws-sdk/client-rds");
var import_client_resource_groups_tagging_api = require("@aws-sdk/client-resource-groups-tagging-api");
var tagging = new import_client_resource_groups_tagging_api.ResourceGroupsTaggingAPIClient();
var rds = new import_client_rds.RDSClient();
async function handler(input) {
  const snapshotsResponse = await tagging.send(new import_client_resource_groups_tagging_api.GetResourcesCommand({
    TagFilters: input.tags.map((f) => {
      return { Key: f.Key, Values: [f.Value] };
    }),
    ResourceTypeFilters: [input.isCluster ? "rds:cluster-snapshot" : "rds:snapshot"]
  }));
  if (!snapshotsResponse.ResourceTagMappingList) {
    console.error("No snapshots found");
  }
  const snapshots = [];
  snapshotsResponse.ResourceTagMappingList.forEach((r) => {
    const id = r.ResourceARN?.split(":").pop();
    if (id) {
      snapshots.push(id);
    } else {
      console.error(`Bad response from tagging API: ${r}`);
    }
  });
  snapshots.sort();
  const toDelete = snapshots.slice(0, -1 * input.historyLimit);
  for (const snapshot of toDelete) {
    console.log(`Deleting old snapshot: ${snapshot}`);
    if (input.isCluster) {
      await rds.send(new import_client_rds.DeleteDBClusterSnapshotCommand({
        DBClusterSnapshotIdentifier: snapshot
      }));
    } else {
      await rds.send(new import_client_rds.DeleteDBSnapshotCommand({
        DBSnapshotIdentifier: snapshot
      }));
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
