"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/find-snapshot.lambda.ts
var find_snapshot_lambda_exports = {};
__export(find_snapshot_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(find_snapshot_lambda_exports);
var import_client_rds = require("@aws-sdk/client-rds");
var rds = new import_client_rds.RDSClient();
async function handler(input) {
  let marker = void 0;
  let lastSnapshotId = "";
  let lastSnapshotTime = 0;
  do {
    if (!input.isCluster) {
      const snapshots = await rds.send(new import_client_rds.DescribeDBSnapshotsCommand({
        DBInstanceIdentifier: input.databaseIdentifier,
        Marker: marker
      }));
      for (const snapshot of snapshots.DBSnapshots ?? []) {
        if (snapshot.DBSnapshotIdentifier && snapshot.SnapshotCreateTime && snapshot.SnapshotCreateTime.getTime() > lastSnapshotTime) {
          lastSnapshotTime = snapshot.SnapshotCreateTime.getTime();
          lastSnapshotId = snapshot.DBSnapshotIdentifier;
        }
      }
      marker = snapshots.Marker;
    } else {
      const snapshots = await rds.send(new import_client_rds.DescribeDBClusterSnapshotsCommand({
        DBClusterIdentifier: input.databaseIdentifier,
        Marker: marker
      }));
      for (const snapshot of snapshots.DBClusterSnapshots ?? []) {
        if (snapshot.DBClusterSnapshotIdentifier && snapshot.SnapshotCreateTime && snapshot.SnapshotCreateTime.getTime() > lastSnapshotTime) {
          lastSnapshotTime = snapshot.SnapshotCreateTime.getTime();
          lastSnapshotId = snapshot.DBClusterSnapshotIdentifier;
        }
      }
      marker = snapshots.Marker;
    }
  } while (marker);
  if (lastSnapshotId === "") {
    throw new Error("No snapshots found");
  }
  return {
    id: lastSnapshotId
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
