"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/test-wait.lambda.ts
var test_wait_lambda_exports = {};
__export(test_wait_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(test_wait_lambda_exports);
var import_client_rds = require("@aws-sdk/client-rds");
var import_client_sfn = require("@aws-sdk/client-sfn");
var sfn = new import_client_sfn.SFNClient();
var rds = new import_client_rds.RDSClient();
async function handler(input) {
  console.log(input.RequestType, input.PhysicalResourceId);
  if (input.RequestType == "Create" || input.RequestType == "Update") {
    const exec = await sfn.send(new import_client_sfn.DescribeExecutionCommand({ executionArn: input.PhysicalResourceId }));
    if (exec.status == "ABORTED" || exec.status == "FAILED" || exec.status == "TIMED_OUT") {
      throw new Error(`Step function failed with: ${exec.status}`);
    }
    if (exec.status == "RUNNING") {
      return { IsComplete: false };
    }
    if (!exec.output) {
      throw new Error("No output?");
    }
    const output = JSON.parse(exec.output);
    if (output.isCluster) {
      const snapshots = await rds.send(new import_client_rds.DescribeDBClusterSnapshotsCommand({ DBClusterSnapshotIdentifier: output.targetSnapshotId }));
      if (!snapshots.DBClusterSnapshots || snapshots.DBClusterSnapshots.length != 1) {
        throw new Error(`Target cluster snapshot ${output.targetSnapshotId} does not exist`);
      }
      await rds.send(new import_client_rds.DeleteDBClusterSnapshotCommand({ DBClusterSnapshotIdentifier: output.targetSnapshotId }));
    } else {
      const snapshots = await rds.send(new import_client_rds.DescribeDBSnapshotsCommand({ DBSnapshotIdentifier: output.targetSnapshotId }));
      if (!snapshots.DBSnapshots || snapshots.DBSnapshots.length != 1) {
        throw new Error(`Target instance snapshot ${output.targetSnapshotId} does not exist`);
      }
      await rds.send(new import_client_rds.DeleteDBSnapshotCommand({ DBSnapshotIdentifier: output.targetSnapshotId }));
    }
    return { IsComplete: true };
  }
  return { IsComplete: true };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
