"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/wait.lambda.ts
var wait_lambda_exports = {};
__export(wait_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(wait_lambda_exports);
var import_client_rds = require("@aws-sdk/client-rds");
var rds = new import_client_rds.RDSClient();
var NotReady = class extends Error {
  constructor() {
    super("Not ready");
    this.name = "NotReady";
  }
};
function checkStatus(status, source) {
  for (const badStatus of ["stop", "delet", "fail", "incompatible", "inaccessible", "error"]) {
    if (status.indexOf(badStatus) >= 0) {
      throw new Error(`Invalid status ${status} for ${source}`);
    }
  }
  throw new NotReady();
}
function empty(obj) {
  return obj === void 0 || obj === null || Object.keys(obj).length == 0;
}
async function handler(input) {
  console.log(input);
  if (input.resourceType == "snapshot" && input.snapshotIdentifier) {
    let status;
    if (input.isCluster) {
      const snapshots = await rds.send(new import_client_rds.DescribeDBClusterSnapshotsCommand({
        DBClusterIdentifier: input.databaseIdentifier,
        DBClusterSnapshotIdentifier: input.snapshotIdentifier
      }));
      console.log(snapshots);
      if (!snapshots.DBClusterSnapshots || snapshots.DBClusterSnapshots.length != 1) {
        throw new Error(`Unable to find snapshot ${input.snapshotIdentifier} of ${input.databaseIdentifier}`);
      }
      status = snapshots.DBClusterSnapshots[0].Status ?? "";
    } else {
      const snapshots = await rds.send(new import_client_rds.DescribeDBSnapshotsCommand({
        DBInstanceIdentifier: input.databaseIdentifier,
        DBSnapshotIdentifier: input.snapshotIdentifier
      }));
      console.log(snapshots);
      if (!snapshots.DBSnapshots || snapshots.DBSnapshots.length != 1) {
        throw new Error(`Unable to find snapshot ${input.snapshotIdentifier} of ${input.databaseIdentifier}`);
      }
      status = snapshots.DBSnapshots[0].Status ?? "";
    }
    if (status == "available") {
      return;
    }
    checkStatus(status, input.snapshotIdentifier);
  } else if (input.resourceType == "cluster") {
    const dbs = await rds.send(new import_client_rds.DescribeDBClustersCommand({
      DBClusterIdentifier: input.databaseIdentifier
    }));
    console.log(dbs);
    if (!dbs.DBClusters || dbs.DBClusters.length != 1) {
      throw new Error(`Unable to find db clsuter ${input.databaseIdentifier}`);
    }
    const status = dbs.DBClusters[0].Status ?? "";
    if (status == "available" && empty(dbs.DBClusters[0].PendingModifiedValues)) {
      return;
    }
    checkStatus(status, input.databaseIdentifier);
  } else if (input.resourceType == "instance") {
    const instances = await rds.send(new import_client_rds.DescribeDBInstancesCommand({
      DBInstanceIdentifier: input.databaseIdentifier
    }));
    console.log(instances);
    if (!instances.DBInstances || instances.DBInstances.length != 1) {
      throw new Error(`Unable to find db instance ${input.databaseIdentifier}`);
    }
    const status = instances.DBInstances[0].DBInstanceStatus ?? "";
    if (status == "available" && empty(instances.DBInstances[0].PendingModifiedValues)) {
      return;
    }
    checkStatus(status, input.databaseIdentifier);
  } else {
    throw new Error("Bad parameters");
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
